# -*- coding:utf-8 -*-
import datetime as dt
import numpy as np
import os
import copy
from rio3.base import enumerator

SQLALCHEMY_ECHO = False
DO_PROF = False

MYSQL_DB_WR_ENGINE_STRING = r'mysql+mysqlconnector://sqlwr:XYsqlwr123456a99@rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com:3306/db_his?charset=utf8'
MYSQL_DB_RD_ENGINE_STRING = r'mysql+mysqlconnector://sqlro:XYsqlrd654321a88@rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com:3306/db_his?charset=utf8'

RT01_DB_RT_WR_ENGINE_STRING = r'mssql+pyodbc://sqlwr:sqlwr123456Y99@120.25.241.11/db_rt?driver=SQL+SERVER?charset=gbk'
RT01_DB_RT_RD_ENGINE_STRING = r'mssql+pyodbc://sqlro:sqlro123456X66@120.25.241.11/db_rt?driver=SQL+SERVER?charset=gbk'

RT01_DB_HIS_WR_ENGINE_STRING = r'mssql+pyodbc://sqlwr:sqlwr123456Y99@120.25.241.11/db_his?driver=SQL+SERVER?charset=gbk'
RT01_DB_HIS_RD_ENGINE_STRING = r'mssql+pyodbc://sqlro:sqlro123456X66@120.25.241.11/db_his?driver=SQL+SERVER?charset=gbk'

RT03_DB_RT_WR_ENGINE_STRING = r'mssql+pyodbc://sqlwr:sqlwr123456Y99@139.196.221.236/db_rt?driver=SQL+SERVER?charset=gbk'
RT03_DB_RT_RD_ENGINE_STRING = r'mssql+pyodbc://sqlro:sqlro123456X66@139.196.221.236/db_rt?driver=SQL+SERVER?charset=gbk'

RT03_DB_HIS_WR_ENGINE_STRING = r'mssql+pyodbc://sqlwr:sqlwr123456Y99@139.196.221.236/db_his?driver=SQL+SERVER?charset=gbk'
RT03_DB_HIS_RD_ENGINE_STRING = r'mssql+pyodbc://sqlro:sqlro123456X66@139.196.221.236/db_his?driver=SQL+SERVER?charset=gbk'

DB_TRADE_WR_ENGINE_STRING = r'mysql+mysqlconnector://sqlwr:XYsqlwr123456a99@rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com:3306/db_trade?charset=utf8'
DB_TRADE_RD_ENGINE_STRING = r'mysql+mysqlconnector://sqlro:XYsqlrd654321a88@rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com:3306/db_trade?charset=utf8'

DB_STRATEGY_WR_ENGINE_STRING = r'mssql+pyodbc://sqlwr:sqlwr123456Y99@139.196.221.236/db_strategy?driver=SQL+SERVER?charset=gbk'
DB_STRATEGY_RD_ENGINE_STRING = r'mssql+pyodbc://sqlro:sqlro123456X66@139.196.221.236/db_strategy?driver=SQL+SERVER?charset=gbk'

DB_STOCK_WR_ENGINE_STRING = r'mysql+mysqlconnector://sqlwr:XYsqlwr123456a99@rm-uf68e6c5ajjftcau1fo.mysql.rds.aliyuncs.com:3306/stock_db?charset=utf8'
DB_STOCK_RD_ENGINE_STRING = r'mysql+mysqlconnector://sqlro:XYsqlrd654321a88@rm-uf68e6c5ajjftcau1fo.mysql.rds.aliyuncs.com:3306/stock_db?charset=utf8'

DB_OPTION_WR_ENGINE_STRING = r'mysql+mysqlconnector://sqlwr:XYsqlwr123456a99@rm-uf68e6c5ajjftcau1fo.mysql.rds.aliyuncs.com:3306/options_db?charset=utf8'
DB_OPTION_RD_ENGINE_STRING = r'mysql+mysqlconnector://sqlro:XYsqlrd654321a88@rm-uf68e6c5ajjftcau1fo.mysql.rds.aliyuncs.com:3306/options_db?charset=utf8'

# 运营系统
DB_OPERATION_RD_ENGINE_STRING = r'mysql+mysqlconnector://sqlrd_web:XYsqlrd654321a88@rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com:3306/db_operation?charset=utf8'
# 官网系统
DB_WEB_RD_ENGINE_STRING = r'mysql+mysqlconnector://sqlrd_web:XYsqlrd654321a88@rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com:3306/db_web?charset=utf8'

DEFAULT_DB_WR_ENGINE_STRING = MYSQL_DB_WR_ENGINE_STRING
DEFAULT_DB_RD_ENGINE_STRING = MYSQL_DB_RD_ENGINE_STRING

DB_HIS_STRING = ';'.join([
    'DRIVER={MySQL ODBC 5.3 ANSI Driver}',
    'SERVER=rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com',
    'PORT=3306',
    'DATABASE=db_his',
    'UID=sqlro',
    'PWD=XYsqlrd654321a88'
])

DB_147_STRING = ';'.join([
    'DRIVER={SQL SERVER}',
    'SERVER=192.168.0.147',
    'DATABASE=db_his',
    'UID=sqlwr',
    'PWD=sqlwr654321Y99'
])

DB_RT1_STRING = ';'.join([
    'DRIVER={SQL SERVER}',
    'SERVER=120.25.241.11',
    'DATABASE=db_rt',
    'UID=sqlwr',
    'PWD=sqlwr123456Y99'
])

DB_RT3_RD_STRING = ';'.join([
    'DRIVER={SQL SERVER}',
    'SERVER=139.196.221.236',
    'DATABASE=db_rt',
    'UID=sqlro',
    'PWD=sqlro123456X66'
])

DB_RT3_STRING = ';'.join([
    'DRIVER={SQL SERVER}',
    'SERVER=139.196.221.236',
    'DATABASE=db_rt',
    'UID=sqlwr',
    'PWD=sqlwr123456Y99'
])

DB_STRATEGY_STRING = ';'.join([
    'DRIVER={SQL SERVER}',
    'SERVER=139.196.221.236',
    'DATABASE=db_strategy',
    'UID=sqlwr',
    'PWD=sqlwr123456Y99'
])

DB_STRATEGY_RD_STRING = ';'.join([
    'DRIVER={SQL SERVER}',
    'SERVER=139.196.221.236',
    'DATABASE=db_strategy',
    'UID=sqlro',
    'PWD=sqlro123456X66'
])

DB_TASK_STRING = ';'.join([
    'DRIVER={MySQL ODBC 5.3 ANSI Driver}',
    'SERVER=rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com',
    'PORT=3306',
    'DATABASE=db_task',
    'UID=taskwr',
    'PWD=XYtaskwr123456a99'
])

DB_WEB_STRING = ';'.join([
    'DRIVER={MySQL ODBC 5.3 ANSI Driver}',
    'SERVER=rm-uf605nn2go0mj7q49o.mysql.rds.aliyuncs.com',
    'PORT=3306',
    'DATABASE=db_web',
    'UID=sqlrd_web',
    'PWD=XYsqlrd654321a88'
])

DB_STOCK_WR_STRING = ';'.join([
    'DRIVER={MySQL ODBC 5.3 ANSI Driver}',
    'SERVER=rm-uf68e6c5ajjftcau1fo.mysql.rds.aliyuncs.com',
    'PORT=3306',
    'DATABASE=stock_db',
    'UID=sqlwr',
    'PWD=XYsqlwr123456a99'
])

DEFAULT_REDIS_STRING = 'redis://:redisxy123456R88@r-uf6fb5d61707be84pd.redis.rds.aliyuncs.com:6401'
PYTHON_REDIS_URL = 'redis://:redisxy123456R88@publicpystrategy.redis.rds.aliyuncs.com:6401'
BACKUP_REDIS_URL = 'redis://:redisxy123456R88@backupstrategynode.redis.rds.aliyuncs.com:6401'
STOCK_REDIS_URL = 'redis://:redisxy123456R88@stockstrategy.redis.rds.aliyuncs.com:6401'

DEFAULT_REDIS_HOST = 'r-uf6fb5d61707be84pd.redis.rds.aliyuncs.com'
BACKUP_REDIS_HOST = 'backupstrategynode.redis.rds.aliyuncs.com'
PYTHON_REDIS_HOST = 'publicpystrategy.redis.rds.aliyuncs.com'
STOCK_REDIS_HOST = 'stockstrategy.redis.rds.aliyuncs.com'
DEFAULT_REDIS_PORT = 6401
DEFAULT_REDIS_PASSWD = 'redisxy123456R88'

HOST_NAME_DICT = {
    'iZ94r5job8wZ': 'RT01',
    '10_105_12_239': 'RT02',
    'iZuf6jdh2ap4dmZ': 'RT03',
    'iZ11dq52yhhZ': 'Trade01',
    'iZ11c9iuk74Z': 'Trade02',
    'iZ11ewhdnr7Z': 'Trade03',
    'iZ11m6yivgsZ': 'Trade04',
    'iZ11ad2ukm4Z': 'Trade05',
    'iZ11f1bxzb8Z': 'Trade06',
    'iZ11ru51ajbZ': 'Trade07',
    'WIN-7A61S39T361': 'Trade08',
    'iZdj8jpj91iuciZ': 'Trade09',
    'iZ11hox76tsZ': 'Trade100',
    'iZ1lwx6zp13xnkZ': 'Trade200',
    'iZyewrepskjfipZ': 'Trade400',
    'jbl01': 'trade_jbl_01',
    'web1': 'trade_jbl_02',
    'iZbtk3puur2oc0Z': 'trade_jt',
    'iZq194wvga0201Z': 'trade_zr',
    'iZ8lqoacl6nqdrZ': 'trade_dy'
}

DEFAULT_EMAIL_ADDRS = [
    '304524916@qq.com',  # 王孜文
    'huahuabill@qq.com',  # 胡昊华
]

# 数据库需要更新的Kline周期
DB_UPDATE_PERIOD = [enumerator.ENUM_PERIOD.OneMinute,
                    enumerator.ENUM_PERIOD.FiveMinutes,
                    enumerator.ENUM_PERIOD.FifteenMinutes,
                    enumerator.ENUM_PERIOD.HalfHour,
                    enumerator.ENUM_PERIOD.OneHour]

SETTLEMENT_EMAIL_ACCONT = {
    'name': 'imap.exmail.qq.com',
    'user': 'settlement@xuanyeinvest.com',
    'passwd': 'Abcd12345',
    'port': 993,
    'ssl': True
}

# 根据SQL small datetime设定允许的最大，最小时间
DATETIME_MIN = dt.datetime(1900, 1, 1)
DATETIME_MAX = dt.datetime(2079, 6, 6)

# NAS上JQData Stock的存放根目录
# H5_JQ_DAILY_DIR = r'\\nas\share\HDF5\JQData\Daily'
# H5_JQ_KLINE_DIR = r'\\nas\share\HDF5\JQData\KlineH5'
# H5_JQ_DAILY_DIR = r'D:\TempCSV\HDF5\JQData\Daily'
# H5_JQ_KLINE_DIR = r'D:\TempCSV\HDF5\JQData\KlineH5'

# 日更临时解压的CSV存储目录
H5_TEMP_EXTRACT_CSV_DIR = r'\\nas\share\HDF5\TempExtractCSV'

# 源数据解压CSV存储目录
DATA_SOURCE_EXTRACT_CSV_DIR = r'\\nas\share\HDF5\TempCSV'

# NAS share 8T上的路径
H5_JQ_DAILY_DIR = r'\\nas\share\HDF5\JQData\Daily'
H5_JQ_KLINE_DIR = r'\\nas\share\HDF5\JQData\KlineH5'
H5_JQ_TKLINE_DIR = r'\\nas\share\HDF5\JQData\TKlineH5'
H5_JQ_COMMON_DIR = r'\\nas\share\HDF5\JQData\Common'
H5_JQ_TRADING_DATA_DIR = r'\\nas\share\HDF5\TradingData'

# NAS上H5 公共数据的存放根目录
H5_COMMON_DATA_DIR = r'\\nas\share\HDF5\CacheHDF5\Common'
if not os.path.exists(r'\\nas\share\HDF5\CacheHDF5\Common'):
    H5_COMMON_DATA_DIR = r'D:\HDF5Data\Common'

# NAS上新版研究数据（震球数据）的存放根目录
ZQ_H5_KLINE_DIR = r'\\nas\share\HDF5\ZQ_H5\CacheHDF5\KlineH5'
ZQ_H5_TKLINE_DIR = r'\\nas\share\HDF5\ZQ_H5\CacheHDF5\TKlineH5'

# NAS上原始研究数据（微盛原始数据）的存放根目录
COMMON_H5_TICK_DIR = r'\\nas\share\HDF5\CacheHDF5\TickH5'
COMMON_H5_KLINE_DIR = r'\\nas\share\HDF5\CacheHDF5\KlineH5'
COMMON_H5_TKLINE_DIR = r'\\nas\share\HDF5\CacheHDF5\TKlineH5'

# 商品期货交易时间表
NAS_FUTURE_LEGAL_PERIOD_JSON_PATH = r'\\nas\share\HDF5\CacheHDF5\Common\FutureLegalPeriod.json'

COMMODITY_DAY_CUTOFF_HOUR = 18

SYMBOL_DICT = {
    'SQ': ["cu", "al", "zn", "pb", "ni", "sn", "au", "ag", "rb", "hc", "fu", "bu", "ru", "sp", "ss"],
    'DL': ["m", "y", "a", "p", "c", "cs", "jd", "bb", "b", "fb", "l", "v", "pp", "j", "jm", "i", "eg", "rr", "eb", "eg",
           'pg', 'lh'],
    'ZZ': ["SR", "CF", "ZC", "FG", "TA", "MA", "WH", "RI", "JR", "RS", "OI", "RM", "SF", "SM", "AP", "CY", "CJ",
           "UR", "SA", "PF"],
    'SF': ["IF", "IC", "IH", "T", "TF"],
    'SE': ["sc", "nr", "lu", "bc"]
}

# 默认需要缓存的指数列表, SH990300/SH990905/SH990906/SH999906 是等权指数， SH999906是全市场但不包括SH000906
DEFAULT_INDEX_STOCK = ['SH000016',
                       'SH000300',
                       'SH000905',
                       'SH000906',
                       'SH990300',
                       'SH990905',
                       'SH990906',
                       'SH999906',
                       'SZ399905',
                       'SZ399906',
                       'SZ399908',
                       'SZ399909',
                       'SZ399910',
                       'SZ399911',
                       'SZ399912',
                       'SZ399913',
                       'SZ399914',
                       'SZ399915',
                       'SZ399916',
                       'SZ399917']

# 股票/期货代码所处的文件夹Security分类
SECURITY_DIR_DICT = {
    'stock': ['SH', 'SZ', 'SI'],
    'commodity_future': ['SQ', 'ZZ', 'DL', 'SE'],
    'index_future': ['SF'],
    'sw': ['SW'],
    'conbond': ['CB']
}

# JQData格式的TICK合并规则定义
MERGE_TICK_DICT = {
    'contract': 'last',
    'volume': 'sum',
    'amount': 'sum',
    'a1_p': 'last',
    'a1_v': 'last',
    'b1_p': 'last',
    'b1_v': 'last',
    'a2_p': 'last',
    'a2_v': 'last',
    'b2_p': 'last',
    'b2_v': 'last'
}

# Resample 分钟线合并规则
MERGE_KLINE_DICT = {
    'date': 'last',
    'today': 'last',
    'open': 'first',
    'high': 'max',
    'low': 'min',
    'close': 'last',
    'pre_close': 'first',
    'amount': 'sum',
    'vol': 'sum',
    'high_limit': 'last',
    'low_limit': 'last',
    'avg': 'last',
    'oi': 'last',
    'contract': 'last',
    'mid': 'last',
    'midv': 'last',
    'factor': 'last',
    'symbol': 'last'
}

# Resample 期权面板数据合并规则
MERGE_OPTIONS_PANEL_KLINE_DICT = {
    'date': 'last',
    'today': 'last',
    'open': 'first',
    'high': 'max',
    'low': 'min',
    'close': 'last',
    'amount': 'sum',
    'vol': 'sum',
    'oi': 'last',
    'contract': 'last',
    'symbol': 'last',
    'underlying_open': 'first',
    'underlying_high': 'max',
    'underlying_low': 'min',
    'underlying_close': 'last',
    'underlying_amount': 'sum',
    'underlying_vol': 'sum',
    'underlying_code': 'last',
    'underlying_name': 'last',
    'dividend_date': 'last',
    'trading_code': 'last',
    'contract_type': 'last',
    'exercise_price': 'last',
    'contract_unit': 'last',
    'expire_date': 'last',
    'last_trade_date': 'last',
    'list_date': 'last',
    'is_adjust': 'last',
    'exercise_type': 'last',
    'pair_code': 'last',
    'pair_trading_code': 'last',
    'pair_code_contract_unit': 'last',
    'pair_code_exercise_price': 'last',
    'pair_code_is_adjust': 'last',
    'pair_code_list_date': 'last',
    'pair_code_expire_date': 'last',
    'pair_code_last_trade_date': 'last',
    'pair_code_dividend_date': 'last',
    'pair_code_exercise_type': 'last',
    'days_to_maturity': 'last',
    'intrinsic_value': 'last',
    'time_value': 'last',
    'gamma': 'last',
    'theta': 'last',
    'vega': 'last',
    'iv': 'last',
    'delta': 'last',
    'rho': 'last'
}

# Datafeed返回的ZQ格式的数据列
ZQ_KLINE_FORMAT_COLUMNS = ['date', 'today', 'span', 'open', 'close', 'high', 'low', 'vol', 'amount', 'mid', 'midv',
                           'sts', 'ets', 'oi', 'factor', 'high_limit', 'low_limit', 'avg', 'pre_close', 'symbol',
                           'contract', 'kidx', 'didx', 'grid']

# H5缓存的ZQ格式的数据列
ZQ_KLINE_ORG_COLUMNS = ['date', 'today', 'span', 'open', 'close', 'high', 'low', 'vol', 'amount', 'high_limit',
                        'low_limit', 'avg', 'pre_close', 'sts', 'ets', 'oi', 'factor', 'contract']

# 期权研究面板数据集合
ZQ_OPTIONS_PANEL_FORMAT_COLUMNS = ['date', 'today', 'span', 'open', 'close', 'high', 'low', 'vol', 'amount', 'oi',
                                   'sts', 'ets', 'contract', 'symbol', 'underlying_open', 'underlying_high',
                                   'underlying_low', 'underlying_close', 'underlying_amount', 'underlying_vol',
                                   'underlying_code', 'underlying_name', 'dividend_date', 'trading_code',
                                   'contract_type', 'exercise_price', 'contract_unit', 'expire_date', 'last_trade_date',
                                   'list_date', 'is_adjust', 'exercise_type', 'pair_code', 'pair_trading_code',
                                   'pair_code_contract_unit', 'pair_code_exercise_price', 'pair_code_is_adjust',
                                   'pair_code_list_date', 'pair_code_expire_date', 'pair_code_last_trade_date',
                                   'pair_code_dividend_date', 'pair_code_exercise_type', 'days_to_maturity',
                                   'intrinsic_value', 'time_value']

ZQ_KLINE_ORG_COLUMNS_DTYPES_DICT = {
    'date': np.int64,
    'today': np.int64,
    'span': np.int64,
    'open': np.float64,
    'close': np.float64,
    'high': np.float64,
    'low': np.float64,
    'vol': np.float64,
    'amount': np.float64,
    'high_limit': np.float64,
    'low_limit': np.float64,
    'pre_close': np.float64,
    'avg': np.float64,
    'sts': np.int64,
    'ets': np.int64,
    'oi': np.int64,
    'factor': np.float64,
    'contract': np.str
}

TRANSACTIONS_DTYPES_DICT = {
    'id_key': np.int64,
    'id_simulation': np.int64,
    'id_model_open': np.int64,
    'stockfullcode': str,
    'stockcode': str,
    'open_model_name': str,
    'open_model_alias': str,
    'date_openposition': 'datetime64[ns]',
    'val_open_price': np.float64,
    'val_open_volume': np.float64,
    'amt_open_volume_available': np.float64,
    'id_model_close': np.int64,
    'close_model_name': str,
    'close_model_alias': str,
    'date_closeposition': 'datetime64[ns]',
    'val_close_price': np.float64,
    'val_close_volume': np.float64,
    'amt_close_volume_available': np.float64,
    'val_revenue_pct': np.float64,
    'flg_short': np.int64,
    'val_weight': np.float64,
    'val_total_hold_ticks': np.int64,
    'memo': str
}

# 策略流水输出列
TRANS_COLUMNS = ['id_key', 'id_stock', 'id_simulation', 'id_model_open', 'stockfullcode', 'stockcode',
                 'open_model_name',
                 'open_model_alias', 'date_openposition', 'val_open_price', 'val_open_volume',
                 'amt_open_volume_available', 'id_model_close', 'close_model_name', 'close_model_alias',
                 'date_closeposition', 'val_close_price', 'val_close_volume', 'amt_close_volume_available',
                 'val_revenue_pct', 'flg_short', 'val_weight', 'val_total_hold_ticks', 'memo']

# 期权标的合约缩写与JQ代码的对应关系
OPTIONS_UNDERLYING_CODE = {
    '50ETF': 'SH510050',
    '300ETF': 'SH510300',
    '300ETF_JS': 'SZ159919',
    'INDEX': 'SH000300',
    'FUTURE': None
}

# 过期的期货主力合约
EXPIRED_MAIN_CONTRACT = ['DLfb9001', 'DLbb9001', 'ZZWT9001', 'ZZWS9001', 'ZZWH9001', 'ZZRS9001',
                         'ZZRO9001', 'ZZRI9001', 'ZZPM9001', 'ZZLR9001', 'ZZJR9001', 'ZZER9001',
                         'ZZME9001', 'ZZTC9001', 'ZZRO9001']

BASKET_LOTS_COLUMNS = ['id', 'tday', 'name', 'symbol', 'strategy_name', 'close', 'lots', 'reference_amount',
                       'excluded', 'memo', 'update_time']
BASKET_LOTS_COLUMNS_EXTRA = copy.deepcopy(BASKET_LOTS_COLUMNS)
BASKET_LOTS_COLUMNS_EXTRA.extend(['volume_multiple'])
