# -*- coding:utf-8 -*-
from enum import Enum


class ENUM_ED_TYPE(Enum):
    NoneEd = 0
    PreEd = 1
    PostEd = 2
    FixEd = 3


class ENUM_PERIOD(Enum):
    Unknown = -10
    Tick = 0
    OneSecond = 1
    FiveSeconds = 5
    FifteenSeconds = 15
    ThirtySeconds = 30
    OneMinute = 60
    FiveMinutes = 300
    TenMinutes = 600
    FifteenMinutes = 900
    HalfHour = 1800
    OneHour = 3600
    HalfDay = 43200
    OneDay = 86400
    OneWeek = -2
    OneQuarter = -4
    Year = -5


class ENUM_TRADE_DIRECT(Enum):
    Buy = 0
    Sell = 1


class ENUM_TRADE_OFFSET(Enum):
    Open = 0
    Close = 1
    ForceClose = 2
    CloseToday = 3
    CloseYesterday = 4
    ForceOff = 5
    LocalForceClose = 6


class ENUM_DB_GROUP(Enum):
    GRP_COMMON = 1
    GRP_KLINE = 1
    GRP_TRADE = 2
    GRP_TASK = 3
    GRP_WEB = 4


class ENUM_MARKET(Enum):
    SH = 1
    SZ = 2
    SF = 4
    UNKNOWN = 5
    DL = 19
    ZZ = 20
    SQ = 21
    SE = 37


# Chart Category
class ENUM_CHART_TYPE(Enum):
    LINE = 0
    LABEL = 1
    RECTANGLE = 2
    ELLIPSE = 3
    VERTICAL_LINE = 4
    INFINITE_LINE = 5
    ANDREWS_PITCH_FORK = 6
    MARKER = 7
    EVENT_MARKER = 8


class ENUM_MARKER_TYPE(Enum):
    ARROW_UP = 0
    ARROW_DOWN = 1


class H5_NODE_LEVEL(Enum):
    DAILY = 0
    MONTHLY = 1


class ENUM_PROFIT_ANALYSIS_SOURCE_TYPE(Enum):
    ORIGINAL = 0
    FILTERED_DOWN = 1
    FILTERED = 2
    FILTERED_UP = 3


class VOT_COST(Enum):
    COST0 = 0.0000
    COST1 = 0.0002
    COST2 = 0.0004


class VOT_DEAL_DATE(Enum):
    DAY = 0
    WEEK = 1
    MONTH = 2
    YEAR = 3
    QUARTER = 4


class VOT_DEAL_TYPE(Enum):
    ALL = 0
    LONG = 1
    SHORT = 2


class VOT_FLOW(Enum):
    SECT = 1  # 分段
    POST_CLASSIFY = 2  # 后验
    PRE_CLASSIFY = 3  # 先验


class VOT_SECT(Enum):
    NO_SECT = 0  # 不分类
    DEAL_TYPE = 1  # Long/Short
    DEAL_DATE = 2  # 周期收益
    DEAL_COUNT = 3  # 交易次数
    DA_TDAY = 4  # 行情交易日


class ENUM_DA_SOURCE_TYPE(Enum):
    HDF5 = 0
    MYSQL = 1
    RT01 = 2
    RT03 = 3


class ENUM_SYMBOL_TYPE(Enum):
    ALL = 0
    FUTURE = 1
    STOCK = 2


class ENUM_FUTURE_TYPE(Enum):
    NONE = -1
    ALL = 0
    STOCK_INDEX = 1
    COMMODITY = 2




