# -*- coding:utf-8 -*-
import logging
import os
import socket
import unittest
import uuid
import re
import urllib
from rio3.base.constant import HOST_NAME_DICT


def normalize_hostname(host=None):
    if host is None:
        host = os.environ.get('computername')
    return HOST_NAME_DICT.get(host, host)


def get_local_ipaddr():
    return socket.gethostbyname(socket.gethostname())


def get_public_ipaddr():
    ip = None
    try:
        # resp = urllib.request.urlopen('http://ip.chinaz.com/getip.aspx').read()
        # ip = re.search(r'\d+\.\d+\.\d+\.\d+', resp).group(0)
        ip = None
    except:
        logging.exception('Exception in get_public_ipaddr')
    return ip


def get_public_or_local_ip_addr():
    ip = get_public_ipaddr()
    if ip is None:
        ip = get_local_ipaddr()
    return ip


def get_mac_address():
    mac = uuid.UUID(int=uuid.getnode()).hex[-12:]
    return ":".join([mac[e:e + 2] for e in range(0, 11, 2)])


class HostTest(unittest.TestCase):
    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_get_public_ipaddr(self):
        ip = get_public_ipaddr()
        self.assertNotEqual(ip, None)

    def test_get_local_ipaddr(self):
        ip = get_local_ipaddr()
        self.assertNotEqual(ip, None)
