# -*- coding:utf-8 -*-
import cProfile
import pstats
import unittest
from rio3.base import constant


# 性能分析装饰器定义
def do_cprofile(filename):
    """
    Decorator for function profiling.
    """

    def wrapper(func):
        def profiled_func(*args, **kwargs):
            if constant.DO_PROF:
                profile = cProfile.Profile()
                profile.enable()
                result = func(*args, **kwargs)
                profile.disable()
                # Sort stat by internal time.
                sortby = "tottime"
                ps = pstats.Stats(profile).sort_stats(sortby)
                ps.dump_stats(filename)
            else:
                result = func(*args, **kwargs)
            return result

        return profiled_func

    return wrapper


class ProfileTest(unittest.TestCase):
    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_view_prof_result(self):
        prof_file_path = r'D:\TempCSV\options_data\back_test_cta.prof'
        p = pstats.Stats(prof_file_path)
        p.sort_stats("tottime")
        p.strip_dirs().sort_stats('time').print_stats()
        p.print_callers()  # 可以显示函数被哪些函数调用
        p.print_callees()  # 可以显示哪个函数调用了哪些函数
        pass

    # @do_cprofile('d:\\get_last_update_kline_by_view.prof')
    # def get_last_update_kline_by_view(self):
    #     from rio3.datafeed import models
    #     from rio3.wind.api import get_sector_constituent
    #     update_date_dict = self.sdio.get_last_updated_kline_date(models.OneDayView, get_sector_constituent(sector=u'沪深300'))
    #     return update_date_dict
    #
    # def test_do_cprofile(self):
    #     constant.DO_PROF = True
    #     update_date_dict = self.get_last_update_kline_by_table()
    #     self.assertEqual(len(update_date_dict), 300)
    #     self.assertEqual(os.path.exists('d:\\get_last_update_kline_by_table.prof'), True)
    #     update_date_dict = self.get_last_update_kline_by_view()
    #     self.assertEqual(len(update_date_dict), 300)
    #     self.assertEqual(os.path.exists('d:\\get_last_update_kline_by_view.prof'), True)
